#include <sysint.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include <mtypes.h>
#include <st.h>
#include <strop.h>
#include <fop.h>
#include <efint.h>





long ffindbol(FILE *fp,long pos)
/*
   Funkcija v odprti datoteki na katero kaze kazalec fp
   najde pozicijo prvega znaka v vrstici, kjer se nahaja
   trenutna pozicija pos, steta od zacetka datoteke.
   $A Damjan apr97;
*/

{
long i=pos,ret=-1;

if ((pos>0) && (pos<flength(fp)))
{
  fflush(fp);
  i-=1;
  ret=pos;
  while ((ret>=pos) && (i>0))
  {
    ret=filechar(fp,"\n\r",2,i,20);
    i-=1;
  }
  ret+=1;
} 
return ret;
}


int comparenodenumbers(void *p1,void *p2)
    /* Primerja vozlisci, ki sta zapisani v podatku tipa nodcoord, po zapored.
    stevilki. Funkcija vrne -1, ce je zap. stevilka vozlisca p1 manjsa od
    zaporedne stevilke vozlisca p2, 0, ce sta koordinati enaki, drugace pa 1.
    */
{
nodcoord n1,n2;
n1= (nodcoord) p1; n2= (nodcoord) p2;
if (n1==NULL || n2==NULL)
  return 0;
else if (n1->i<n2->i)
  return -1;
else if (n1->i==n2->i)
  return 0;
else return 1;
}


stack createimage(stack list,stack reference)
      /* Vrne sklad, na katerega so nalozeni kazalci na vsa tista vozlisca na
      skladu s2, ki so tudi na skladu s1. Ce je kateri od skladov prazen, je
      tudi rezultat funkcije prazen sklad in ce je kateri od skladov enak NULL,
      je taksen tudi rezultat. Na sklad, ki ga vrne fukcija, so nalozeni le
      kazalci na vozlisca na sklasu reference, prostor za zapis vozlisc se torej
      ne rezervira! */
{
stack ret=NULL;
int i,j;
if (list!=NULL && reference!=NULL)
{
  ret=newstack(20);
  if (list->n!=0 && reference->n!=0)
  {
    for (i=1;i<=list->n; ++i)
    {
      j=findstack(reference,list->s[i],0,0,comparenodenumbers);
      if (j>0)
      {
        pushstack(ret,reference->s[j]);
      }
    }
  }
}
return ret;
}


stack createhardimage(stack list,stack reference,int size)
      /* Podobno kot createimage, le, da se ne skopirajo kazalci, ki so na
      skladu, ampak objekti, na katere ti kazalci kazejo. Zato funkcija rabi
      dodaten argument size, ki je velikost taksnega objekta v bytih. */
{
stack ret=NULL;
int i,j;
void *p;
if (list!=NULL && reference!=NULL && size>0)
{
  ret=newstack(5);
  if (list->n!=0 && reference->n!=0)
  {
    for (i=1;i<=list->n; ++i)
    {
      j=findstack(reference,list->s[i],0,0,comparenodenumbers);
      if (j>0)
      {
        /*  pushstack(ret,reference->s[j]);  */
        p=malloc(size);
        pushstack(ret,p);
        if (reference->s[j]!=NULL)
          memcpy(p,reference->s[j],size);
      }
    }
  }
}
return ret;
}


long copyfilepart(FILE *fp1,long from,long to,FILE *fp2,int bufsize)
    /* Iz datoteke fp1 skopira del od byta from do vkljucno byta to (steti se
    zacne z 1) na datoteko fp2. Zapis na datoteko fp2 se zacne pri trenutni
    poziciji v tej datoteki. Bufsize je velikost pomoznega pomnilnika.
      Funkcija vrne stevilo uspesno prenesenih bytov.
      Ce je to enak 0, postane enak dolzini datoteke. */
{
long ret=0,rd=0,length,all;
void *buf=NULL;
int doread,wasread,waswritten;
char end=0;
length=flength(fp1);
if (fp1!=NULL && fp2!=NULL && from>0 && from<=length && (to>from || to==0) )
{
  if (to==0) to=length;
  if (to>length) to=length;
  if (bufsize<=0) bufsize=500;
  all=to-from+1;    /* toliko bytov naj bi se prepisalo */
  if (bufsize>all) bufsize=all;
  buf=malloc(bufsize);
  fseek(fp1,from-1,SEEK_SET);
  while (!end)
  {
    doread=all-rd;
    if (doread>bufsize)
      doread=bufsize;
    wasread=fread(buf,1,doread,fp1);
    rd+=wasread;
    waswritten=fwrite(buf,1,wasread,fp2);
    ret+=waswritten;
    if (feof(fp1) || rd>=all)
      end=1;
  }
fflush(fp2);
}
if (buf!=NULL)
  free(buf);
return ret;
}


int ffindnodefield(char *keystr,FILE *fp,long from,long *first,long *last)
     /* V vhodni datoteki za program Elfen fp najde vozliscno polje, doloceno
     z nizom keystr (za vozliscne koordinate je to npr. "NODE COORDINATES", za
     predpisane pomike "PRESCRIBED DISP" itd.). Funkcija vrne zacetek
     polja v begin (1. znak za tistim \n ali \r, ki je v isti vrstici kot
     niz keystr) in konec v end (znak \n ali \r za zadnjim zapisom vozlisca).
     Funkcija vrne stevilo vozlisc, ki so zabelezena v polju.
     */
{
int buflength=1000,ret=0,length;
double x;
char end=0,ch;
long pos,pos1,pos2;
*first=*last=-1;
if (from<=0) from=1;
pos=filestring(fp,keystr,from,buflength);
if (pos<=0)
  ret=-1;
else
{
  ret=0;
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
    end=1;
  pos1=filenotchar(fp,"\n\r",3,pos,20);
  if (pos1>0) *first=pos1;
  while (!end)
  {
    *last=pos;
    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);
    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {
      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;
    } else
    {
      ++ret;
      pos=filechar(fp,"\n\r",2,pos2,20);
      if (pos<=0)
      {
        pos=0;
        end=1;
      }
    }
  }
}
return ret;
}


int fresfindnodefield(char *keystr,FILE *fp,long from,long *first,long *last)
     /* V datoteki rezultatov programa Elfen fp najde vozliscno polje, doloceno
     z nizom keystr (za vozliscne koordinate je to npr. "NODE COORDINATES", za
     predpisane pomike "PRESCRIBED DISP" itd.). Funkcija vrne zacetek
     polja v begin (1. znak za tistim \n ali \r, ki je v isti vrstici kot
     niz keystr) in konec v end (znak \n ali \r za zadnjim zapisom vozlisca).
     Funkcija vrne stevilo vozlisc, ki so zabelezena v polju.
     */
{
int buflength=1000,ret=0,length,passes=0;
double x;
char end=0,ch;
long pos,pos1,pos2;
*first=*last=-1;
if (from<=0) from=1;
pos=filestring(fp,keystr,from,buflength);
if (pos<=0)
  ret=-1;
else
{
  ret=0;
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
    end=1;
  pos1=filenotchar(fp,"\n\r",3,pos,20);
  if (pos1>0) *first=pos1;
  while (!end)
  {
    ++passes;
    *last=pos;
    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);
    if (passes==1) pos1=pos2;
    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {
      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;
    } else
    {
      ++ret;
      pos=filechar(fp,"\n\r",2,pos2,20);
      if (pos<=0)
      {
        pos=0;
        end=1;
      }
    }
  }
}
return ret;
}


int freadnodefield(char *keystr,FILE *fp,long from,stack nod)
     /* Iz vhodne datoteke za program Elfen fp prebere vozliscno polje, doloceno
     z nizom keystr (za vozliscne koordinate je to npr. "NODE COORDINATES", za
     predpisane pomike "PRESCRIBED DISP" itd.) z njihovimi koordinatami
     in jih nalozi na sklad nod. Podatki o vozliscih so nalozeni v podatke tipa
     nodcoord.
     */
{
int buflength=1000,ret=0,length;
double x;
char end=0,ch;
long pos,pos1,pos2;
nodcoord nc=NULL;
if (from<=0) from=1;
if (nod==NULL)
{
  end=1;
  ret=-1;
}
pos=filestring(fp,keystr,from,buflength);
if (pos<=0)
  ret=-1;
else
{
  if (!end)
    nc=malloc(sizeof(*nc));
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
  {
    end=1;
    ret=-1;
  }
  while (!end)
  {

    /* printf("1 "); */

    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);

    /* printf("2 "); */

    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {

      /* printf("3 "); */

      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;

      /* printf("4 "); */

    } else
    {

      /* printf("5 "); */

      nc->i=(int) x;
      nc->x=0;
      nc->y=0;
      nc->z=0;
      pos=filechar(fp,"\n\r",2,pos2,50);

      /* printf("6 "); */

      if (pos<=0)
      {
        pos=0;
        end=1;
      }
      x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

      /* printf("7 "); */

      if (pos2>0)
      {

        /* printf("8 "); */

        nc->x=x;
        x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

        /* printf("9 "); */

        if (pos2>0)
        {
          nc->y=x;
          x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

          /* printf("10 "); */

          if (pos2>0)
          {
            nc->z=x;
          }
        }
      }

      /*
      printf("11 ");
      */

      pushstack(nod,nc);
      nc=malloc(sizeof(*nc));
    }
  }
}
if (nc!=NULL)
  free(nc);
return ret;
}


int fresreadnodefield(char *keystr,FILE *fp,long from,stack nod)
     /* Iz datoteke rezultatov za program Elfen fp prebere vozliscno polje, doloceno
     z nizom keystr (za vozliscne koordinate je to npr. "NODE COORDINATES", za
     predpisane pomike "PRESCRIBED DISP" itd.) z njihovimi koordinatami
     in jih nalozi na sklad nod. Podatki o vozliscih se nalozijo v podatke tipa
     nodcoord.
     */
{
int buflength=1000,ret=0,length,passes=0;
double x;
char end=0,ch;
long pos,pos1,pos2;
nodcoord nc=NULL;

/*
FILE *err=0;
err=fopen("0err","wb");
*/

if (from<=0) from=1;
if (nod==NULL)
{
  end=1;
  ret=-1;
}
pos=filestring(fp,keystr,from,buflength);
if (pos<=0)
  ret=-1;
else
{
  if (!end)
    nc=malloc(sizeof(*nc));
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
  {
    end=1;
    ret=-1;
  }
  while (!end)
  {
    ++passes;

    /*
    fprintf(err,"\n P%i ",passes);
    fflush(err);
    fprintf(err,"1 "); fflush(err);
    */

    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);
    if (passes==1) pos1=pos2;

    /*
    fprintf(err,"2 "); fflush(err);
    */

    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {

      /*
      fprintf(err,"3 "); fflush(err);
      */

      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;

      /*
      fprintf(err,"4 "); fflush(err);
      */

    } else
    {

      /*
      fprintf(err,"5 "); fflush(err);
      */

      nc->i=(int) x;
      nc->x=0;
      nc->y=0;
      nc->z=0;
      pos=filechar(fp,"\n\r",2,pos2,50);

      /*
      fprintf(err,"6 "); fflush(err);
      */

      if (pos<=0)
      {
        pos=0;
        end=1;
      }
      x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

      /*
      fprintf(err,"7 "); fflush(err);
      */

      if (pos2>0)
      {

        /*
        fprintf(err,"8 "); fflush(err);
        */

        nc->x=x;
        x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

        /*
        fprintf(err,"9 "); fflush(err);
        */

        if (pos2>0)
        {

          nc->y=x;
          x=filenumto(fp,pos2+length,pos,20,&pos2,&length);

          /*
          fprintf(err,"10 "); fflush(err);
          */

          if (pos2>0)
          {
            nc->z=x;
          }
        }
      }

      /*
      fprintf(err,"11 "); fflush(err);
      fprintf(err,"X "); fflush(err);
      */

      pushstack(nod,nc);
      nc=malloc(sizeof(*nc));
    }
  }
}
if (nc!=NULL)
  free(nc);

/*
fclose(err);
*/

return ret;
}


int freadnodecoords(FILE *fp,long from,stack nod)
{
return freadnodefield("NODE COORDINATES",fp,from,nod);
}


int fresreadnodecoords(FILE *fp,long from,stack nod)
{
return fresreadnodefield("NODE COORDINATES",fp,from,nod);
}


int freadnodeprescdisp(FILE *fp,long from,stack nod)
{
return freadnodefield("PRESCRIBED DISP",fp,from,nod);
}


int fresreadnodeprescdisp(FILE *fp,long from,stack nod)
{
return fresreadnodefield("PRESCRIBED DISP",fp,from,nod);
}


int fresnreadnodecoords(FILE *fp,int which,stack nod)
    /* Iz datoteke fp, ki je datoteka rezultatov direktne analize, prebere polje
    vozliscnih koordinat z zaporedno stevilko which glede na mesto v datoteki
    (ce je v datoteki vec polj, ki opisujejo predpisane pomike). */
{
int n;
long from;
stack st=NULL;
st=newstack(5);
if (nod==NULL || which<0) return -1;
n=filestringall(fp,"NODE COORDINATES",1,1000,st);
if ( n>0 && (which==0 || n>=which) )
{
  if (which==0) which=n;
  from=* (long *) st->s[which];
  fresreadnodefield("NODE COORDINATES",fp,from,nod);
  if (nod->n>0)
    return nod->n;
  else
    return -1;
} else return -1;
}


int fnreadnodeprescdisp(FILE *fp,int which,stack nod)
    /* Iz datoteke fp, ki je vhodna datoteka za direktno analizo, prebere polje
    predpisanih pomikov z zaporedno stevilko which glede na mesto v datoteki
    (ce je v datoteki vec polj, ki opisujejo predpisane pomike). */
{
int n;
long from;
stack st=NULL;
st=newstack(5);
if (nod==NULL || which<0) return -1;
n=filestringall(fp,"PRESCRIBED DISP",1,1000,st);
if ( n>0 && (which==0 || n>=which) )
{
  if (which==0) which=n;
  from=* (long *) st->s[which];
  freadnodefield("PRESCRIBED DISP",fp,from,nod);
  if (nod->n>0)
    return nod->n;
  else
    return -1;
} else return -1;
}


int fresnreadnodeprescdisp(FILE *fp,int which,stack nod)
    /* Iz datoteke fp, ki je datoteka rezultatov direktne analize, prebere polje
    predpisanih pomikov z zaporedno stevilko which glede na mesto v datoteki
    (ce je v datoteki vec polj, ki opisujejo predpisane pomike). */
{
int n;
long from;
stack st=NULL;
st=newstack(5);
if (nod==NULL || which<0) return -1;
n=filestringall(fp,"NODE COORDINATES",1,1000,st);
if ( n>0 && (which==0 || n>=which) )
{
  if (which==0) which=n;
  from=* (long *) st->s[which];
  fresreadnodefield("PRESCRIBED DISP",fp,from,nod);
  if (nod->n>0)
    return nod->n;
  else
    return -1;
} else return -1;
}


void fwritenodecoords(FILE *fp,stack nodes,int dim)
     /* V datoteko fp izpise polje vozliscnih koordinat, nalozenih na sklad 
     nodes. Izpis se zacne pri trenutni poziciji v datoteki. dim je dimenzija
     polja, ki se izpise. */
{
int i;
nodcoord nc;
if (nodes==NULL)
  fprintf(fp,"  PRAZEN SKLAD.\n");
else if (nodes->n<=0)
  fprintf(fp,"  NA SKLADU NI NOBENEGA VOZLISCA.\n");
else
{
  for (i=1; i<=nodes->n; ++i)
  {
    nc= (nodcoord) nodes->s[i];
    if (nc!=NULL)
    {
      fprintf(fp,"  %-5i  %15.10g",nc->i,nc->x);
      if (dim>=2)
        fprintf(fp,"  %15.10g",nc->y);
      if (dim>=3)
        fprintf(fp,"  %15.10g",nc->z);
      fprintf(fp,"\n");
    }
  }
}
if (fp!=NULL) fflush(fp);
}


int freadnodeconstr(FILE *fp,stack nod)
     /* Iz vhodne datoteke za program Elfen fp prebere 1. polje podpor vozlisc v
     datoteki in jih nalozi na sklad nod. Podatki o vozliscih se nalozijo v
     podatke tipa nodcoonstr.
     */
{
int buflength=1000,ret=0,length;
double x;
char *keystr="RESTRAINED NODES",end=0,ch,cstr[3];
long pos,pos1,pos2;
nodconstr nc=NULL;
if (nod==NULL)
{
  end=1;
  ret=-1;
}
pos=filestring(fp,keystr,1,buflength);
if (pos<=0)
  ret=-1;
else
{
  if (!end)
    nc=malloc(sizeof(*nc));
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
  {
    end=1;
    ret=-1;
  }
  while (!end)
  {
    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);
    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {
      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;
    } else
    {
      nc->i=(int) x;
      nc->x=0;
      nc->y=0;
      nc->z=0;
      pos=filechar(fp,"\n\r",2,pos2,20);
      if (pos<=0)
      {
        pos=0;
        end=1;
      }
      x=filenumto(fp,pos2+length,pos,20,&pos2,&length);
      if (pos2>0)
      {
        cstr[0]=cstr[1]=cstr[2]='0';
        fileread(cstr,1,3,fp,pos2);
        if (cstr[0]=='1')
          nc->x=1;
        if (cstr[1]=='1')
          nc->y=1;
        if (cstr[2]=='1')
          nc->z=1;
      }
      pushstack(nod,nc);
      nc=malloc(sizeof(*nc));
    }
  }
}
if (nc!=NULL)
  free(nc);
return ret;
}


int fnreadnodeconstr(FILE *fp,int which,stack nod)
     /* Iz vhodne datoteke za program Elfen fp prebere polje podpor vozlisc z
     zapovrstno stevilko which; podatke nalozi na sklad nod in so tipa
     nodcoonstr.
     */
{
int buflength=1000,ret=0,length;
double x;
char *keystr="RESTRAINED NODES",end=0,ch,cstr[3];
int n;
long pos,pos1,pos2,from;
nodconstr nc=NULL;
stack st=NULL;
st=newstack(5);
if (nod==NULL || which<0) return -1;
n=filestringall(fp,keystr,1,1000,st);
if ( n>0 && (which==0 || n>=which) )
{
  if (which==0) which=n;
  from=* (long *) st->s[which];
} else return -1;
if (nod==NULL)
{
  end=1;
  ret=-1;
}
pos=filestring(fp,keystr,from,buflength);
if (pos<=0)
  ret=-1;
else
{
  if (!end)
    nc=malloc(sizeof(*nc));
  pos=filechar(fp,"\n\r",2,pos,20);
  if (pos<=0)
  {
    end=1;
    ret=-1;
  }
  while (!end)
  {
    pos1=filenotchar(fp,"\n\r ",3,pos,20);
    x=filenum(fp,pos,20,&pos2,&length);
    if (pos2<=0)
      end=1;
    else if (pos1!=pos2)
    {
      fileread(&ch,1,1,fp,pos1);
      if (ch!='*')
        end=1;
      else
        pos=filechar(fp,"\n\r",2,pos1,50);
      if (pos<=0)
        end=1;
    } else
    {
      nc->i=(int) x;
      nc->x=0;
      nc->y=0;
      nc->z=0;
      pos=filechar(fp,"\n\r",2,pos2,20);
      if (pos<=0)
      {
        pos=0;
        end=1;
      }
      x=filenumto(fp,pos2+length,pos,20,&pos2,&length);
      if (pos2>0)
      {
        cstr[0]=cstr[1]=cstr[2]='0';
        fileread(cstr,1,3,fp,pos2);
        if (cstr[0]=='1')
          nc->x=1;
        if (cstr[1]=='1')
          nc->y=1;
        if (cstr[2]=='1')
          nc->z=1;
      }
      pushstack(nod,nc);
      nc=malloc(sizeof(*nc));
    }
  }
}
if (nc!=NULL)
  free(nc);
return ret;
}


void fwritenodeconstr(FILE *fp,stack nodes,int dim)
     /* V datoteko fp zapise polje vozliscnih podpor, ki so nalozene na skladu
     nodes (podatki morajo biti tipa nodconstr). dim je dimenzija polja. */
{
int i;
nodconstr nc;
if (nodes==NULL)
  fprintf(fp,"  PRAZEN SKLAD.\n");
else if (nodes->n<=0)
  fprintf(fp,"  NA SKLADU NI NOBENEGA VOZLISCA.\n");
else
{
  for (i=1; i<=nodes->n; ++i)
  {
    nc= (nodconstr) nodes->s[i];
    if (nc!=NULL)
    {
      fprintf(fp,"  %i  ",nc->i);
      if (nc->x==0)
        fprintf(fp,"0");
      else
        fprintf(fp,"1");
      if (dim>=2)
      {
        if (nc->y==0)
          fprintf(fp,"0");
       else
          fprintf(fp,"1");
      }
      if (dim>=3)
      {
        if (nc->z==0)
          fprintf(fp,"0");
       else
          fprintf(fp,"1");
      }
      fprintf(fp,"\n");
    }
  }
}
if (fp!=NULL) fflush(fp);
}


int filereplacefield(char *filename1,char *filename2,char *keystr,long from,
                     stack field,int dim,int bufsize)
    /* V datoteki z imenom filename1 nadomesti vozliscno polje, ki ga doloca
    keystr, z vrednostmi, ki so zapisane na skladu field (elementi na tem skladu
    morajo biti tipa nodcoord!). Novo vsebino datoteke zapise v datoteko z
    imenom filename2 (1. datoteka ostane nespremenjena, 2. pa se prepise).
    Pojav polja, ki se nadomesti, se isce od pozicije from naprej (ce je v
    1. datoteki vec polj z istim imenom, se nadomesti 1. ustrezno polje od
    pozicije from naprej).
      dim je stevilo prostostnih stopenj vsakega vozlisca, bufsize pa velikost
    pomoznega pomnilnika.
    */
{
int num,ret=0;
long first,last;
FILE *fp1,*fp2;
if (bufsize<=0)
  bufsize=500;
fp1=fopen(filename1,"rb");
fp2=fopen(filename2,"wb");
if (fp1!=NULL && fp2!=NULL && keystr!=NULL && field!=NULL)
{
  num=ffindnodefield(keystr,fp1,from,&first,&last);
  if (num>0)
  {
    if (first>0)
      copyfilepart(fp1,1,first-1,fp2,bufsize);
    fwritenodecoords(fp2,field,dim);
    if (last>0)
      copyfilepart(fp1,last+1,0,fp2,bufsize);
  } else
  {
    copyfilepart(fp1,1,0,fp2,bufsize);
  }
} else ret=-1;
if (fp1!=NULL) fclose(fp1);
if (fp2!=NULL) fclose(fp2);
return ret;
}


int freadeltopstruct(FILE *fp,long from,eltopstruct elgroup)
/*
	Funkcija iz vhodne datoteke za analizo v programu ELFEN
	prebere prvo skupino elementov ter njihovih vozlisc, ki jih
	najde za mestom from. Stevilo skupine, njen tip in elemente
	nalozi  na strukturo tipa eltopstruct. Funkcija vrne stevilo
	elementov v skupini.
	$A Damjan apr97;
*/

{  
int i=0,*num,len,ret=-1;
long pos,spos,epos,start=0,end=0;
char *str;
stack element;

if (elgroup!=NULL)
{
if ((from>0)&&(from<flength(fp)))  
{
  /* Iskanje stevilke skupine in tipa elementov */
  pos=filestr(fp,"ELEMENT TOPOLOGY",16,from,20);
  i=(int)filenum(fp,pos,20,&start,&len); 
  elgroup->gn=i;
  spos=ffindbol(fp,pos);
  epos=filechar(fp," ",1,spos,20);
  str=malloc(epos-spos+1);
  fileread(str,1,epos-spos,fp,spos);
  str[epos-spos]='\0';
  elgroup->eltype=str;

  /* Iskanje pozicije zacetka=start in konca=end bloka elementov */
  ffindnodefield("ELEMENT TOPOLOGY",fp,from,&start,&end);
  if (start>=1)
  {
    pos=spos=start;			   /* Zacetek vrstice za 1. el */	
    epos=(int)filechar(fp,"\n",1,spos,20); /* Konec vrstice za 1. el*/
    
    /* Dokler ne pridemo do konca bloka */
    while(epos<=end)
    {
      element=newstack(10); 
      while(pos<epos)
      {
        num=malloc(sizeof(*num));
        *num=(int)filenum(fp,pos,20,&start,&len); /* Iskanje stevilke vozlisca */
        pushstack(element,num);	
        pos=start+len;            /* dolocitev trenutne pozicije */
      }
      /* izpis(element); */
      pushstack(elgroup->elements,element);
      ++i;
      spos=(int)filenotchar(fp,"\n\r",2,epos,20); /* Zacetek naslednjega elementa */
      epos=(int)filechar(fp,"\n\r",2,spos,20);    /* Konec naslednjega elementa */
    }  
    ret=i;
  }
}
}
else ret=-1;
return ret; /* Ce iskanje ni uspesno vrne -1, sicer stevilo elementov v bloku*/
}
 
