
#include <sysint.h>

#include <stdlib.h>
#include <stddef.h>
/* #include <stdio.h> */
#include <math.h>
#include <mtypes.h>
#include <sg_obj.h>
#include <strop.h>
#include <grint.h>
#include <gro.h>
#include <sg_graph.h>

#include <grdxf.h>
#include <grps.h>
/*
#include <groio.h>
*/

#include <rf.h>
/* #include <rand.h> */
#include <st.h>
#include <vec.h>

#include <time.h>




double fxy(double x,double y)
{
  return (sin(x)*sin(y));
}

double fxy1(double x,double y)
{
  return 0.5*(x*x+0.5*y*y)-1;
}

double fxy2(double x,double y)
{
  return x+y+0.1*x*y;
}



double R=1.3;


double parx(double fi,double theta)
{
  return R*cos(theta)*cos(fi);
}

double pary(double fi,double theta)
{
  return R*cos(theta)*sin(fi);
}

double parz(double fi,double theta)
{
  return R*sin(theta);
}


double fx(double fi)
{
  return R*cos(fi) +R*sin(60*fi)/30;
}

double fy(double fi)
{
  return R*sin(fi) +R*cos(60*fi)/30;
}

double fz(double fi)
{
  return R*sin(10*fi)/2;
}



double fspher1(double fi,double theta)
{
return 2+0.2*sin(theta)* (sin(6*fi)*cos(8*theta)) ;
}

double fspher2(double fi,double theta)
{
return 2+0.2*sin(theta)* (sin(6*fi)+cos(3*theta)) ;
}

double fspher(double fi,double theta)
{
return 2+0.2*sin(theta)* (sin(6*fi)+1.5*cos(8*theta)) ;
}

double fspher4(double fi,double theta)
{
return 2+0.2*sin(theta)* (sin(6*fi+8*theta)) ;
}

double fspher5(double fi,double theta)
{
return 2*sin(2*theta);
}


double fcyl(double r,double fi)
{
return 0.02*r+1*fi;
}

double fbottle(double z,double fi)
{
return ( 3*exp(-z*z/16)*(1+0.1*cos(2*z+10*fi)) );
}


void calccontourcolorloc1(double z,double min,double max,double mingrey,truecolor color)
{
double halfint,midp,kcol;
if (z<min) z=min;
if (z>max) z=max;
halfint=(max-min)/2;
midp=min+halfint;
kcol=(1-mingrey)/0.5;
if (z<midp)
{
  color->green=(float) ( mingrey+kcol*(z-min)/halfint );
  color->blue=(float) ( 1-color->green+mingrey );
  color->red=(float) mingrey;
} else
{
  color->red=(float) ( mingrey+kcol*((z-midp)/halfint)*((z-midp)/halfint) );
  color->green=(float) ( 1-color->red+mingrey );
  color->blue=(float) mingrey;
}
}

void calccontourcolorloc(double z,double min,double max,truecolor color)
{
double halfint,quartint,midp,qp,kcol,val,halfcol;
double mingrey=0.0,plusmingrey=0.0,power=0.3;
double val1,power1;
power1=1;

if (z<min) z=min;
if (z>max) z=max;
halfcol=mingrey+(1-mingrey)/2;
halfint=(max-min)/2;
quartint=halfint/2;
midp=min+halfint;
kcol=(1-mingrey)/0.5;
if (z<midp)
{
  qp=min+quartint;
  /* mingrey=plusmingrey*(1-fabs(z-qp)/quartint); */
  if (z<qp)
    val=0.5*pow(fabs((z-min)/quartint),power);
  else
    val=1-0.5*pow(fabs((z-midp)/quartint),power);

  if (z<qp)
    val1=0.5*pow(fabs((z-min)/quartint),power1);
  else
    val1=1-0.5*pow(fabs((z-midp)/quartint),power1);
  /* val=0.5*(val+val1); */

  color->green=(float) ( mingrey+val*(1-mingrey) );
  color->blue=(float) ( 1-color->green+mingrey );
  color->red=(float) mingrey;
} else
{
  qp=max-quartint;
  /* mingrey=plusmingrey*(1-fabs(z-qp)/quartint); */
  if (z<qp)
    val=0.5*pow(fabs((z-midp)/quartint),power);
  else
    val=1-0.5*pow(fabs((z-max)/quartint),power);

  if (z<qp)
    val1=0.5*pow(fabs((z-midp)/quartint),power1);
  else
    val1=1-0.5*pow(fabs((z-max)/quartint),power1);
  /* val=0.5*(val+val1); */

  color->red=(float) ( mingrey+val*(1-mingrey) );
  color->green=(float) ( 1-color->red+mingrey );
  color->blue=(float) mingrey;

  /*
  color->red=mingrey+kcol*(z-midp)/halfint;
  color->green=1-color->red+mingrey;
  color->blue=mingrey;
  */


}

/* color->blue=color->red=0; */

}





gogroup testgofwrite(void)
{
_coord3d p1,p2,p3,p4;
gogroup ret=NULL,pom=NULL;
goprimitive prim=NULL,prim1=NULL;
golinesettings ls1,ls;
gofillsettings fs1;
gotextsettings ts1;
goprimitive p;
ret=newgogroupst(2,3,1);
pom=newgogroupst(0,0,1);
pom->name=stringcopy("Podskupina");
pushstack(ret->groups,NULL);
pushstack(ret->groups,(void *) pom);
/*
ret->name=stringcopy("frame3d");
ret->primitives=newstack(5);
ret->groups=newstack(1);
*/
/* Nastavitve za risanje crt: */
ret->ls1=malloc(sizeof(*ret->ls1));
ret->ls1->color.red=1; ret->ls1->color.green=0; ret->ls1->color.blue=0;
ret->ls1->linewidth=2;
ret->ls1->linetype=1;
ret->ls1->extra=NULL;
/* Nastavitve za risanje ploskev: */
ret->fs1=malloc(sizeof(*ret->fs1));
ret->fs1->color.red=0; ret->fs1->color.green=1; ret->fs1->color.blue=0;
ret->fs1->extra=NULL;
/* Nastavitve za risanje teksta: */
ret->ts1=malloc(sizeof(*ret->ts1));
ret->ts1->color.red=0; ret->ts1->color.green=0; ret->ts1->color.blue=1;
ret->ts1->font=1;
ret->ts1->height=0.1;
ret->ts1->spacing=0;
ret->ts1->expansion=1;
ret->ts1->xalignment=0;
ret->ts1->yalignment=0;
ret->ts1->extra=NULL;
/* Nekaj crt: */
p1.x=-1; p1.y=-1; p1.z=-1;
p2.x=1; p2.y=1; p2.z=1;

ls1=ret->ls1;

ls=malloc(sizeof(*ls));
*ls=*ls1;
ls->linewidth=0;
ls->color.red=0;
ls->color.green=1;
ls->color.blue=1;
/*
(goaddline(&p1,&p2,ret->primitives,ret))->props1=ls;
*/

(goaddarrow(&p1,&p2,0.25,0.2,'1','1','0',ret->primitives,ret))->props1=ls;


p1.x=1; p1.y=-1; p1.z=-1;
p2.x=-1; p2.y=1; p2.z=1;


ls=malloc(sizeof(*ls));
*ls=*ls1;
ls->linewidth=2;
/*
goaddline(&p1,&p2,ret->primitives,ret)->props1=ls;
*/

p1.x=-1; p1.y=1; p1.z=-1;
p2.x=1; p2.y=-1; p2.z=1;



ls=malloc(sizeof(*ls));
*ls=*ls1;
ls->linewidth=4;
ls->color.red=1;
ls->color.green=0;
ls->color.blue=1;
/*
goaddline(&p1,&p2,ret->primitives,ret)->props1=ls;
*/

goaddarrow(&p1,&p2,0.4,0.3,'1','1','r',ret->primitives,ret)->props1=ls;


p1.x=-1; p1.y=-1; p1.z=1;
p2.x=1; p2.y=1; p2.z=-1;


ls=malloc(sizeof(*ls));
*ls=*ls1;
ls->linewidth=6;
prim=goaddline(&p1,&p2,ret->primitives,ret);
p3.x=2.321;
p3.y=1.42;
p3.z=-1.2;


/*
pr*im=goaddtriangle(&p1,&p2,&p3,ret->primitives,ret)->props1=ls;
*/



/* Posebne nastavitve za risanje crt za zadnjo crto: */
ls1=malloc(sizeof(*ls1));
ls1->color.red=1; ls1->color.green=0.5; ls1->color.blue=0;
ls1->linewidth=2;
ls1->linetype=1;
ls1->extra=NULL;
prim->props1=ls1;
/* Nekaj ploskev: */
p1.x=-0.3;   p1.y=-0.3;  p1.z=-0.3;
p2.x=0.3;   p2.y=-0.3;  p2.z=-0.3;
p3.x=0.3;   p3.y=0.3;  p3.z=-0.3;
p4.x=-0.3;   p4.y=0.3;  p4.z=-0.3;


/* $$$$$$$$$$$$$$
p=goaddpartbordfourangle(&p1,&p2,&p3,&p4,1,0,0,1,ret->primitives,ret);
p->after=newstack(3);
pushstack(p->after,goaddline(&p1,&p3,ret->extraprimitives,ret));
pushstack(pom->extraprimitives,NULL);


ls=malloc(sizeof(*ls));
*ls=*ls1;
ls->linewidth=8;
pushstack(p->after, (prim1=goaddline(&p2,&p4,pom->extraprimitives,pom) ));

pushstack(pom->extraprimitives,NULL);
pom->ls1=malloc(sizeof(*pom->ls1));
*pom->ls1=*ls1;
p1.x=-0.3;   p1.y=-0.3;  p1.z=0.7;
p2.x=0.3;   p2.y=-0.3;  p2.z=0.9;
p3.x=0.3;   p3.y=0.3;  p3.z=0.9;
p4.x=-0.3;   p4.y=0.3;  p4.z=0.7;
goaddpartbordfourangle(&p1,&p2,&p3,&p4,1,0,0,1,ret->primitives,ret);
p1.x=0.6;   p1.y=0.4;  p1.z=0.2;
p2.x=1.1;   p2.y=0.4;  p2.z=0.2;
p3.x=1.1;   p3.y=-0.4;  p3.z=0.2;
p4.x=0.6;   p4.y=-0.4;  p4.z=0.2;
prim=goaddpartbordfourangle(&p1,&p2,&p3,&p4,1,0,1,0,ret->primitives,ret);

*/


/* Posebne nastavitve za barvanje ploskev za zadnjo ploskec: */

/*$$$$$$$$$$$$$
fs1=malloc(sizeof(*fs1));
fs1->color.red=0; fs1->color.green=1; fs1->color.blue=1;
fs1->extra=NULL;
prim->props1=fs1;
p1.x=0;   p1.y=0;  p1.z=-0.1;
goaddtext("gfjdlkFSAGI",&p1,ret->primitives,ret);


*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->height=0.1;
ts1->font=2;
p1.z=0.9; p1.x=0.1; p1.y=0.1;
 
/*
prim=goaddtext("Font 2",&p1,ret->primitives,ret);
prim->props2=ts1;
*/

/*
prim=goaddmarker(&p1,0.05,1,ret->primitives,ret);
*/

/*

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.1;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=3;
p1.z=0.8; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 3",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.1;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=4;
p1.z=0.7; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 4",&p1,ret->primitives,ret);

prim->props2=ts1;

*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.1;
ts1->color.blue=(float) 0.1; ts1->color.red=(float) 0; ts1->color.green=(float) 0;
ts1->font=5;
p1.z=0.6; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 5",&p1,ret->primitives,ret);

prim->props2=ts1;
/*
prim=goaddmarker(&p1,0.05,2,ret->primitives,ret);
*/

ts1->xalignment=-1;
ts1->yalignment=0;


/*

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.1;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=6;
p1.z=0.5; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 6",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=7;
p1.z=0.4; p1.x=0.1; p1.y=0.1; 


prim=goaddtext("Font 7",&p1,ret->primitives,ret);


prim->props2=ts1;

*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=8;
p1.z=0.3; p1.x=0.1; p1.y=0.1; 

/*$$$$$$$4
prim=goaddtext("Font 8",&p1,ret->primitives,ret);
*/

prim->props2=ts1;
/*
prim=goaddmarker(&p1,0.02,1,ret->primitives,ret);
*/

ts1->xalignment=1;
ts1->yalignment=0;


/*

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=9;
p1.z=0.2; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 9",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=10;
p1.z=0.1; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 10",&p1,ret->primitives,ret);

prim->props2=ts1;

*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=11;
p1.z=0.0; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 11",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1->xalignment=0;
ts1->yalignment=-1;


/*

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=12;
p1.z=-0.1; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 12",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=13;
p1.z=-0.2; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 13",&p1,ret->primitives,ret);

prim->props2=ts1;

*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=(float) 0.1; ts1->color.red=(float) 0; ts1->color.green=(float) 0;
ts1->font=14;
p1.z=-0.3; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 14",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1->xalignment=0;
ts1->yalignment=1;


/*

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=15;
p1.z=-0.4; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 15",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=16;
p1.z=-0.5; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 16",&p1,ret->primitives,ret);

prim->props2=ts1;

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=0.1; ts1->color.red=0; ts1->color.green=0;
ts1->font=17;
p1.z=-0.6; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 17",&p1,ret->primitives,ret);

prim->props2=ts1;

*/

ts1=malloc(sizeof(*ts1));
*ts1=*(ret->ts1);
ts1->height=0.025;
ts1->color.blue=(float) 0.1; ts1->color.red=(float) 0; ts1->color.green=(float) 0;
ts1->font=18;
p1.z=-0.7; p1.x=0.1; p1.y=0.1; 

prim=goaddtext("Font 18",&p1,ret->primitives,ret);

/*
prim=goaddmarker(&p1,0.1,2,ret->primitives,ret);
*/
prim->props2=ts1;

ts1->xalignment=0;
ts1->yalignment=0;


return ret;
}






void main(void)
{


double fi,theta,hfi,htheta,fi1,theta1,hfi1,htheta1,maxlength,maxlength1,x;
int numx,numy,divx,divy,numx1,numy1,divx1,divy1;
int win,win1,win2;
stack st,st1;
clock_t t1,t2;
int i,j,k;
frame3d winlimits=NULL,frame=NULL,winlimits1=NULL,frame1=NULL,framepar=NULL;
stack gost=NULL,gost1=NULL,fst=NULL,testst=NULL;
gogroup gg=NULL,gg1=NULL,gg2=NULL,gg3=NULL,
ggg=NULL,ggg1=NULL,ggg2=NULL,ggg3=NULL,gtest=NULL,gtest1=NULL,gtest2=NULL;
gofillsettings fs=NULL;
golinesettings ls=NULL,ls1=NULL,ls2=NULL;
gotextsettings ts=NULL;
_truecolor col;



gicoloring(1);
ginumshades(8);


/*
giinstallfont(2,"*");
giinstallfont(3,"*");
giinstallfont(4,"*");
giinstallfont(5,"*");
giinstallfont(6,"*");
*/
/*
giinstallfont(2,"rrrrrr897trewe");
giinstallfont(3,"rrrrrr897trewe");
giinstallfont(4,"rrrrrr897trewe");
giinstallfont(5,"rrrrrr897trewe");
giinstallfont(6,"rrrrrr897trewe");
*/

giinstallfont(1,"rrrrrr897trewe");
giinstallfont(2,"*");
giinstallfont(3,"-adobe-courier-bold-o-normal--0-0-75-75-m-0-hp-roman8");
giinstallfont(4,"-adobe-helvetica-bold-o-normal--0-0-75-75-p-0-hp-roman8");
giinstallfont(5,"-bitstream-swiss 742-medium-r-normal--0-0-110-110-p-0-iso8859-1");
giinstallfont(6,"-hp-hp user-medium-r-normal--0-0-85-85-m-0-iso8859-2");
giinstallfont(7,"-hp-hp system-medium-r-normal-sans-0-0-72-72-p-0-iso8859-8");
giinstallfont(8,"-b&h-lucida-medium-i-normal-sans-0-0-75-75-p-0-iso8859-1");




fs=malloc(sizeof(*fs));
ls=malloc(sizeof(*ls));

/* Odprtje graficnih oken: */

giinitdisplay();   giinitgraph();
gisetwindowtitle("okno");
gisetwindowxpos(0); gisetwindowypos(0);
gisetwindowwidth(0.3); gisetwindowheight(0.3);
printf ("Window width: %i.\n",gingetwindowwidth());
printf("Window height: %i.\n",gingetwindowheight());
win=giopenwindow();
gisetwindowxpos(0.5); gisetwindowypos(0);
gisetwindowtitle("okno 1");
win1=giopenwindow();   

/* Test grafike */
gisetlinewidth(4);
gisetlinetype(1);
giline(0,0,2,1);
giflushdisplay();


/* Test funkcije za dolocanje barve kontur: */
j=0;
for (i=1;i<=10;++i)
{
  x=(double) i/10; calccontourcolorloc(x,0,1,&col);
   gisetlinecolor(col.red,col.green,col.blue);
  giline(0,x,1,x); giflushdisplay();
  ++j;
  if (j>=10)
  {
    printf("x=%-5.3g, R=%-6.3g, G=%-6.3g, B=%-6.3g\n",x,col.red,col.green,col.blue);
    j=0;
  }
}
i=getchar();
i=100;
gisetwindow(1); giclearwindow(); giresetwindow();
gisetwindow(2); giclearwindow(); giresetwindow();



numx=8; divx=1; numy=8; divy=1;
numx1=25; divx1=3; numy1=25; divy1=3;
fi=0;     theta=15;
hfi=20; htheta=5;
fi1=30;     theta1=15;
hfi1=20; htheta1=8;



/* ZA 1. OKNO: */



gost=newstack(100);
/* Okvir v oknu, v katerega naj pade 1. graf: */
winlimits=malloc(sizeof(*winlimits));
frame=malloc(sizeof(*frame));
winlimits->min.x=0.1; winlimits->min.y=0.0; winlimits->max.x=0.7; winlimits->max.y=0.8;
/* Geometrijske meje graf. objekta v 1. oknu: */
frame->min.x=-3;    frame->min.y=-1.3;    frame->min.z=-1.6;
frame->max.x=3;     frame->max.y=3;     frame->max.z=5.23;
frame->min.x=-1.3;    frame->min.y=-1.3;    frame->min.z=-1.3;
frame->max.x=1.3;     frame->max.y=1.3;     frame->max.z=1.3;
/* GRAFICNI OBJEKTI ZA 1. OKNO: */
printf("Making graphic objects.\n");
t1=t2=clock();
fs->color.red=0; fs->color.green=0; fs->color.blue=1;
ls->color.red=0; ls->color.green=0.7; ls->color.blue=0.4;
ls->linewidth=2;
ls->linetype=1;
ls1=malloc(sizeof(*ls1)); ls2=malloc(sizeof(*ls2));
ls->color.red=0; ls->color.green=0; ls->color.blue=0.8;
ls->linewidth=1;
ls->linetype=1;
ls1->color.red=0; ls1->color.green=1; ls1->color.blue=0;
ls1->linewidth=1;
ls1->linetype=1;
ls2->color.red=1; ls2->color.green=0; ls2->color.blue=0;
ls2->linewidth=1;
ls2->linetype=1;
gg=gomakeframe3d(frame,ls,ls1,numx*divx+numy*divy,numx*divx+numy*divy,
                 numx*divx+numy*divy);


ls->color.red=0;  ls->color.green=0;  ls->color.blue=1;
fs->color.red=0;  fs->color.green=1;  fs->color.blue=1;

gg1=gosurfaceplot(fxy,numx,divx,numy,divy,frame,fs,ls,7,2);

ls->color.red=0;  ls->color.green=0;  ls->color.blue=1;
fs->color.red=0.8;  fs->color.green=0;  fs->color.blue=0.7;

/*
gg2=gosurfaceplot(fxy1,numx,divx,numy,divy,frame,fs,ls,4,2);
*/

/*
gg1=gocontourplotsimp(fxy,-1,1,10,10,20,frame,ls,0,0.0);
*/

gg2=gocontourplotsimp(fxy1,-1,5,10,10,20,frame,ls,1,0.0);


ls->color.red=0.8;  ls->color.green=0;  ls->color.blue=0;
fs->color.red=1;  fs->color.green=1;  fs->color.blue=0;

ls->color.red=1; ls->color.green=0; ls->color.blue=0;
ls->linewidth=2;
ls->linetype=1;


/*
gg3=gosurfaceplot(fxy2,numx,divx,numy,divy,frame,fs,ls,28,2);
*/


ts=malloc(sizeof(*ts));
ts->color.red=0.5; ts->color.green=0.1; ts->color.blue=0.7;
ts->font=1;
ts->height=0.01;
ts->expansion=1;
ts->xalignment=0;
ts->yalignment=0;


gg3=gomakerulertext3d(frame,ts,6,10,3,0.1);
pushstack(gg3->groups,(void *)
gomakerulers3d(frame,ls,ls1,ls2,10,0.02,0.06,0.1)
);
ts->height=0.03; ts->color.red=0.2; ts->color.green=0.6;
pushstack(gg3->groups,(void *)
gomakeendaxeslabels3d(frame,"X","Y","Z",ts,0.1)
);

goloadtostack(gg3,gost);

/*
gg3=gomakegridbascorner3d(frame,ls,ls1,ls2,10);
*/




/* Preizkusanje izpisa graficnih objektov v datoteko: */
gost=newstack(10);

gtest=NULL;


/*
gtest=testgofwrite();
gofilewritegroup("00",gtest,0,1);
goloadtostack(gtest,gost);
fi+=hfi; theta+=htheta;
gisetwindow(win);
preparegraph3dbas(frame,winlimits);
gosettransfsimp(rad(fi),rad(theta));
godolighting(0);
gotransfgroup(gtest);
godrawstackscreen(gost);
gost=NULL;
giflushdisplay();
getchar();
*/

/*
gtest=testgofwrite();
gofilewritegroup("00",gtest,0,2);
*/

testst=NULL; gtest=NULL; testst=newstack(10);

/*

printf("Reading graph. files:\n");

filereadgofile("003",&testst);
filereadgofile("004",&testst);

printf("GRAPH. FILE READ.\n");


gtest=(gogroup) testst->s[1];
gtest1=(gogroup) testst->s[2];

gofilewritegroup("0",gtest,0,2);
gofilewritegroup("0a",gtest1,0,2);

printf("GRAPH. FILE WRITTEN.\n");

*/


/*
if (testst->n>0)
{
  int i;
  for (i=1;i<=testst->n;++i)
  {
    goloadtostack((gogroup)testst->s[i],gost);
  }
}
*/


gtest=testgofwrite();

gtest1=NULL;


goloadtostack(gtest,gost);


goloadtostack(gtest1,gost);


printf("Loading graphic objects to stack.\n");
goloadtostack(gg3,gost);  /* Okvir */
goloadtostack(gg,gost);   /* Mrezica */


gost=newstack(111); goloadtostack(gtest,gost);


getchar();



printf("cas: %.5g,  celoten cas: %.5g\n\n",
 ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
t1=clock();

printf("cas: %.5g,  celoten cas: %.5g\n\n",
 ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);





/* ZA 2. OKNO: */

gost1=newstack(100);

/* Okvir v oknu, v katerega naj pade 2. graf: */
framepar=malloc(sizeof(*framepar));
winlimits1=malloc(sizeof(*winlimits));
frame1=malloc(sizeof(*frame));
winlimits1->min.x=0; winlimits1->min.y=0; winlimits1->max.x=1;
 winlimits1->max.y=1;
/* Geometrijske meje graf. objekta v 2. oknu: */
frame1->min.x=-3;    frame1->min.y=-3;    frame1->min.z=-2;
frame1->max.x=3;     frame1->max.y=3;     frame1->max.z=2;
/* Meje za parametricni graf: */
framepar->min.x=0; framepar->max.x=rad(360);
 framepar->min.y=rad(0); framepar->max.y=rad(180);
/* GRAFICNI OBJEKTI ZA 2. OKNO: */
/*
printf("Making graphic objects.\n");
t1=t2=clock();
*/
ls->linewidth=1;
ls->linetype=1;
ggg=ggg1=ggg2=ggg3=NULL;



ggg=gomakeframe3d(frame,ls,ls1,numx1*divx1+numy1*divy1,numx1*divx1+numy1*divy1,
                 numx1*divx1+numy1*divy1);

ls->color.red=0.0;  ls->color.green=0.6;  ls->color.blue=1;
fs->color.red=1;  fs->color.green=1;  fs->color.blue=1;

ggg1=gosurfaceplot(fxy,numx1,divx1,numy1,divy1,frame1,fs,ls,8,0);
ggg1=NULL;

/*
ggg2=gosurfaceplotpar(parx,pary,parz,numx1,divx1,numy1,divy1,framepar,fs,ls,0,0);
*/

ggg2=gosurfaceplotbottle(fbottle,numx1,divx1,numy1,divy1,framepar,fs,ls,4,0);


ls->linewidth=2;
ls->color.red=0.8; ls->color.green=0.0; ls->color.blue=0.0;

ggg3=gocurveplot3dpar(fx,fy,fz,1000,1,0,rad(360),ls);
goloadtostack(ggg3,fst);

/*
ls->color.red=0;  ls->color.green=0;  ls->color.blue=1;
fs->color.red=1;  fs->color.green=0;  fs->color.blue=1;
ggg2=gosurfaceplot(fxy1,numx1,divx1,numy1,divy1,frame1,fs,ls,3,2);
ls->color.red=0.5;  ls->color.green=0.5;  ls->color.blue=0.6;
fs->color.red=1;  fs->color.green=1;  fs->color.blue=0;
ggg3=gosurfaceplot(fxy1,numx1,divx1,numy1,divy1,frame1,fs,ls,3,2);
*/
/*
printf("cas: %.5g,  celoten cas: %.5g\n\n",
 ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
t1=clock();
*/

printf("Loading graphic objects to stack.\n");
goloadtostack(ggg,gost1);
goloadtostack(ggg1,gost1);
goloadtostack(ggg2,gost1);
goloadtostack(ggg3,gost1);


/*
printf("\n\nWriting groups to files:\n");
gofilewritegroup("001",ggg,0,2);
gofilewritegroup("002",ggg1,0,2);
gofilewritegroup("003",ggg2,0,2);
gofilewritegroup("004",ggg3,0,2);
printf("End writing.\n");
*/



/*

fst=newstack(100);
goloadtostack(ggg,fst);

/*
godxffiledrawstack("../dxf/gr0.dxf",fst);
*/

fst=newstack(100);
goloadtostack(ggg1,fst);
/*
godxffiledrawstack("../dxf/gr1.dxf",fst);
*/

fst=newstack(100);
goloadtostack(ggg2,fst);
/*
godxffiledrawstack("../dxf/gr2.dxf",fst);
*/


fst=newstack(100);
goloadtostack(ggg3,fst);
/*
godxffiledrawstack("../dxf/gr3.dxf",fst);
*/


/*
godxffiledrawstack("../dxf/gr00.dxf",gost1);
*/


/*
printf("cas: %.5g,  celoten cas: %.5g\n\n",
 ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
*/






st=newstack(1000);
st1=newstack(1000);


/* VIRI SVETLOBE: */
/*
goremovelights();
*/
gosetdifuselight(0.2,0.3,0);
gosetfarlight(0,0.3,0, 0,0,1);
gosetfarlight(1,0.2,0,-1,-0.9,0.2);
gosetfarlight(0,0.2,1,0.8,1,0.2);
gosetfarlight(0,0,1,2,0,-1);
gosetfarlight(0.7,0.8,0.2,0,1,-1);
gosetpowfarlighting(1);
goupdatelightfactor(2.5);

/*
gosetdifuselight(0.2,0.3,0);
gosetfarlight(0,0.3,0, 0,0,-1);
gosetfarlight(1,0.2,0,-1,-0.9,-0.2);
gosetfarlight(0,0.2,1,0.8,1,-0.2);
gosetfarlight(0,0,1,2,0,1);
gosetfarlight(0.7,0.8,0.2,0,1,1);
gosetpowfarlighting(1);
goupdatelightfactor(2.5);
*/


/*
giinstallfont(1,"-adobe-courier-bold-o-normal--8-80-75-75-m-50-hp-roman8");
*/
/*
giinstallfont(2,"blsfdsa");
*/


gisetwindow(1);

/* Test pisav:
gisettextcolor(1,0.5,0);
gisettextfont(3);
gisettextheight(0.05);

gisettextxalignment(0);

gisettextfont(1);
gisettextyalignment(-1);
gitext("sredina spodaj",0.5,0.2);

gisettextfont(2);
gisettextyalignment(0);
gitext("sredina sredina",0.5,0.4);

gisettextfont(3);
gisettextyalignment(1);
gitext("sredina zgoraj",0.5,0.6);

gisettextyalignment(0);

gisettextfont(4);
gisettextxalignment(-1);
gitext("levo sredina",0.5,0.8);

gisettextfont(5);
gisettextxalignment(1);
gitext("desno sredina",0.5,0.9);

giflushdisplay();
getchar();
*/


while(1)
{
  fi+=hfi; theta+=htheta;
  fi1+=hfi1; theta1+=htheta1;
  /*
  printf("fi = %g, theta = %g.\n",fi,theta);
  printf("fi1 = %g, theta1 = %g.\n",fi,theta);
  */
  ++i;

  /* GRAF V 1. OKNU: */
  gisetwindow(win);

  preparegraph3dbas(frame,winlimits);
  gosettransfsimp(rad(fi),rad(theta));

  godolighting(1);

  /*
  printf("Transforming graphic objects on the stack.\n");
  t1=clock(); t2=clock();
  */
  
  /*
  gotransfgroup(gg);
  gotransfgroup(gg1);
  gotransfgroup(gg2);
  gotransfgroup(gg3);
  gotransfgroup(gtest);
  gotransfgroup(gtest1);
  */
  gotransfstack(gost);
  
  /*
  printf("ZAPIS GRAFICNIH OBJEKTOV V DATOTEKO; ggg= %i\n",ggg);
  gofilewritegroup("0grobj",ggg1,0,1);
  */

  /*printf("cas: %.5g,  celoten cas: %.5g\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();
  printf("Sorting graphic objects on the stack.\n");
  */
  gosortstack(gost);

  /*
  printf("cas: %.5g,  celoten cas: %.5g\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();
  printf("Drawing graphic objects.\n");
  /*

  if (i>5)
  {

    giclearwindow();
    giresetwindow();

  }
  /* Brisanje zaslona */
  
  gisetfillcolor(1,1,1);
  gifillrectangle(0,0,1,1);
  
  godrawstackscreen(gost);
  giflushdisplay();
  
  
  printf("Writing transformed objects to ps and dxf file.\n");
  gofilewritegroup("0.igf",gtest,0,2);
  
  /*
  gopsfiledrawstack("0.ps",gost);
  gotclfiledrawstack("0.tcl",gost);

  godxffiledrawstack("0.dxf",gost);
  godxffiledrawstack("01.dxf",gost);
  
  gotclfiledrawstack("01.tcl",gost1);
  */
  
  printf("Done.\n\n");
  sleep(2);
  
  /*
  printf("Writing transformed objects to DXF file.\n");
  dxfiledrawstack("../dxf/gr0.dxf",gost);
  printf("Done.\n\n");
  */
  

  /*
  printf("cas: %.5g,  celoten cas: %.5g\n\n\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();



  /* GRAF V 2. OKNU: */
  gisetwindow(win1);

  preparegraph3dbas(frame1,winlimits1);
  gosettransfsimp(rad(fi1),rad(theta1));

  godolighting(1);

  /*
  printf("Transforming graphic objects on the stack.\n");
  */
  t1=clock(); t2=clock();
  gotransfgroup(ggg);
  gotransfgroup(ggg1);
  gotransfgroup(ggg2);
  gotransfgroup(ggg3);

  /*
  printf("cas: %.5g,  celoten cas: %.5g\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();
  printf("Sorting graphic objects on the stack.\n");
  */

  gosortstack(gost1);

  /*
  printf("cas: %.5g,  celoten cas: %.5g\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();
  printf("Drawing graphic objects.\n");
  */
  if (i>5)
  {

    giclearwindow();
    giresetwindow();

  }
  /* Brisanje zaslona */
  gisetfillcolor(1,1,1);
  gifillrectangle(0,0,1,1);
  
  /*
  godrawstackscreen(gost1);
  */
  
  giflushdisplay();
  
  /*
  printf("Writing transformed objects to DXF file.\n");
  dxffiledrawstack("../dxf/gr00.dxf",gost1);
  printf("Done.\n\n");
  */
  

  /*
  printf("cas: %.5g,  celoten cas: %.5g\n\n\n\n",
   ((double)(clock()-t1))/(double)CLOCKS_PER_SEC,((double)(clock()-t2))/(double)CLOCKS_PER_SEC);
  t1=clock();
  */

  if (i>5) i=0;
}



}



